﻿
// Copyright 2014-2017, Anitoa Systems, LLC
// All rights reserved

// TestBBDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestBB.h"
#include "TestBBDlg.h"
#include "IntTimeDlg.h"
#include "afxdialogex.h"
#include "HidMgr.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//....................................................................

// Global variables for this application

CDC *g_pDC = NULL;

// extern BYTE TxData[TxNum];		// the buffer of sent data to HID
extern BYTE RxData[RxNum];			// the buffer of received data from HID

extern BOOL g_DeviceDetected;
extern bool	MyDeviceDetected;

HWND hWnd;						// This is a way to give a windows handle to the HIDMgr

extern BOOL Continue_Flag;

#define pixelsize24 10		// display size for one pixel
#define pixelsize12 20		// display size for one pixel

int gain_mode = 0;			// 0 high gain, 1 low gain. HW initial high gain mode. However, SW default is low gain
float int_time = 1;			// integration time
int g_FrameSize = 0;		// 0: 12x12 frame; 1: 24x24 frame

//....................................................................

// USB HID related routines. Please do not change

void CTestBBDlg::SendHIDRead()
{
	WPARAM a = 8;
	LPARAM b = 9;
	HWND hwnd = AfxGetApp()->GetMainWnd()->GetSafeHwnd();
	::SendMessage(hwnd,WM_ReadHID_event,a,b);
}

LRESULT CTestBBDlg::Main_OnDeviceChange(WPARAM wParam, LPARAM lParam)  
{

	//DisplayData("Device change detected.");

	PDEV_BROADCAST_HDR lpdb = (PDEV_BROADCAST_HDR)lParam;

		if(FindTheHID()) {
			m_InterfaceObject.ResetTrim();
//			GetFWVersion();
			SetDlgItemText(IDC_STATICOpenComm,"ULS24 Device Detected");
		}
		else {
			SetDlgItemText(IDC_STATICOpenComm,"Device Not Detected");
		}

	switch(wParam) 
	{
		// Find out if a device has been attached or removed.
		// If yes, see if the name matches the device path name of the device we want to access.

	case DBT_DEVICEARRIVAL:
//		DisplayData("A device has been attached.");

		if (DeviceNameMatch(lParam))
		{
//			DisplayData("My device has been attached.");
		}

		return TRUE; 

	case DBT_DEVICEREMOVECOMPLETE:
//		DisplayData("A device has been removed.");

		if (DeviceNameMatch(lParam))
		{
//			DisplayData("My device has been removed.");

			// Look for the device on the next transfer attempt.

			MyDeviceDetected = false;
		}
		return TRUE; 

	default:
		return TRUE; 
	} 
}


LRESULT CTestBBDlg::OnReadHID(WPARAM wParam, LPARAM lParam)
{
	ReadHIDInputReport();
	return 0;
}

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnDestroy();
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
	ON_WM_DESTROY()
END_MESSAGE_MAP()

// Main dialog box implementation

// CTestBBDlg dialog


CTestBBDlg::CTestBBDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CTestBBDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_GainMode = 0;		// Low gain mode
	m_DisplayText.Empty();
}

void CTestBBDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Radio(pDX, IDC_RADIO_L, m_GainMode);
}

BEGIN_MESSAGE_MAP(CTestBBDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_CAPTURE, &CTestBBDlg::OnBnClickedButtonCapture)
	ON_MESSAGE(WM_ReadHID_event,OnReadHID)
	ON_MESSAGE(WM_DEVICECHANGE, Main_OnDeviceChange)
	ON_BN_CLICKED(IDC_BUTTON_CAPTURE24, &CTestBBDlg::OnBnClickedButtonCapture24)
	ON_BN_CLICKED(IDC_RADIO_L, &CTestBBDlg::OnBnClickedRadioL)
	ON_BN_CLICKED(IDC_RADIO_H, &CTestBBDlg::OnBnClickedRadioH)
	ON_BN_CLICKED(IDC_BUTTON_INTTIME, &CTestBBDlg::OnBnClickedButtonInttime)
	ON_BN_CLICKED(IDC_BUTTONA, &CTestBBDlg::OnBnClickedButtona)
	ON_BN_CLICKED(IDC_BUTTONB, &CTestBBDlg::OnBnClickedButtonb)
	ON_BN_CLICKED(IDC_BUTTONC, &CTestBBDlg::OnBnClickedButtonc)
	ON_BN_CLICKED(IDC_BUTTON_CLR, &CTestBBDlg::OnBnClickedButtonClr)
END_MESSAGE_MAP()


// CTestBBDlg message handlers


BOOL CTestBBDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Load trim data. This is a necessary step for ULS24 to function correctly

	m_InterfaceObject.SetDlg(this);

	int e = m_InterfaceObject.LoadTrimFile();

	CString mess = "( Trim Loaded: ";
	
	if(e) {
		mess += m_InterfaceObject.GetChipName();
		mess += " )";
		SetDlgItemText(IDC_STATIC, mess);
	}
	else {
		SetDlgItemText(IDC_STATIC,"Trim Data Not Loaded");
	}

	if(!e) {
		MessageBox("ULS24 device trim data not loaded, the program may not run correctly.");
	}

	// End load trim data

	hWnd = m_hWnd;

	if(FindTheHID()) {
		m_InterfaceObject.ResetTrim();
		SetDlgItemText(IDC_STATICOpenComm,"ULS24 Device Detected");
	}
	else {
		SetDlgItemText(IDC_STATICOpenComm,"Device Not Detected");
	}

	CString sbuf;

	sbuf.Format("%.0f  ", int_time);
	SetDlgItemText(IDC_STATIC_INTTIME, sbuf);

	m_InterfaceObject.Initialize();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestBBDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestBBDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestBBDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

//////////////////////////////////////////////////////////////////
// Below are demo codes for application developer to customize
//////////////////////////////////////////////////////////////////

void CTestBBDlg::OnBnClickedButtonCapture()
{
	if(!g_DeviceDetected) {
		MessageBox("ULS24 Device Not Attached", "TestBB", MB_ICONWARNING);
		return;
	}

	if(g_pDC == NULL) g_pDC=GetDlgItem(IDC_DISPLAY)->GetDC();					// Setup display context for drawing
	m_InterfaceObject.CaptureFrame12();

	for(int i=0; i<12; i++) {
		DrawPattern(i, 0);
	}

	DisplayFrameText();
}

void CTestBBDlg::OnBnClickedButtonCapture24()
{
	if(!g_DeviceDetected) {
		MessageBox("ULS24 Device Not Attached", "TestBB", MB_ICONWARNING);
		return;
	}

	if(g_pDC == NULL) g_pDC=GetDlgItem(IDC_DISPLAY)->GetDC();	
	m_InterfaceObject.CaptureFrame24();

	for(int i=0; i<24; i++) {
		DrawPattern(i, 0);
	}

	DisplayFrameText();
}


void CTestBBDlg::DrawPattern(int row, int contrast)
{
	int grayl[24];

	int i=0;
	int l=0;
	int gray_level=0;

	// RxData[5] is the row number.

    int rn = row;
	int num_col;

	if(g_pDC == NULL) g_pDC=GetDlgItem(IDC_DISPLAY)->GetDC();					// Setup display context for drawing

	if(!g_FrameSize) num_col = 12;
	else num_col = 24;

	if(contrast > 100) contrast = 100;
	else if (contrast < 0) contrast = 0;

	int div = 16 - contrast / 7;

	for (i=0; i<num_col; i++)
	{
		gray_level = m_InterfaceObject.frame_data[rn][i]/16;
		if(gray_level > 255) gray_level = 255;
		else if(gray_level < 0) gray_level = 0;

		grayl[i] = gray_level;
	}

	for(int l=0; l<num_col; l++)		//
	{
		if(g_pDC && !g_FrameSize) 
			g_pDC->FillSolidRect((pixelsize12*l),(pixelsize12*rn),pixelsize12,pixelsize12, RGB(grayl[l], grayl[l], grayl[l]));
		else if(g_pDC && g_FrameSize) 
			g_pDC->FillSolidRect((pixelsize24*l),(pixelsize24*rn),pixelsize24,pixelsize24, RGB(grayl[l], grayl[l], grayl[l]));
	}
}

void CAboutDlg::OnDestroy()
{
	CDialogEx::OnDestroy();

	// TODO: Add your message handler code here
}


void CTestBBDlg::OnCancel()
{
	// TODO: Add your specialized code here and/or call the base class

	int result = MessageBox("OK to close?", "TestBB", MB_ICONQUESTION | MB_OKCANCEL);

	if(result != IDOK) return;

	if(g_pDC) g_pDC->DeleteDC();
	m_InterfaceObject.CleanUp();

	CDialogEx::OnCancel();
}


void CTestBBDlg::OnBnClickedRadioL()
{
	// TODO: Add your control notification handler code here
	UpdateData(true);

	m_InterfaceObject.SetGainMode(!m_GainMode);
}


void CTestBBDlg::OnBnClickedRadioH()
{
	// TODO: Add your control notification handler code here
	UpdateData(true);

	m_InterfaceObject.SetGainMode(!m_GainMode);

}

void CTestBBDlg::InsertText(CString s)
{
	m_DisplayText += s;						//
 	SetDlgItemText(IDC_EDIT_TEXT, m_DisplayText);
}

void CTestBBDlg::DisplayFrameText()
{
	int nr, nc;
	CString s;

	s.Empty();

	if(!g_FrameSize) {
		nr = 12;
		nc = 12;
	}
	else {
		nr = 24;
		nc = 24;
	}

	for(int i=0; i<nr; i++) {
		s.Format("%d: ", i);
		m_DisplayText += s;
		for(int j=0; j<nc; j++) {
			s.Format("%d ", m_InterfaceObject.frame_data[i][j]);
			m_DisplayText += s;
		}
		m_DisplayText += "\r\n";
	}
	m_DisplayText += "\r\n";
 	
	SetDlgItemText(IDC_EDIT_TEXT, m_DisplayText);
}

void CTestBBDlg::OnBnClickedButtonInttime()
{
	// TODO: Add your control notification handler code here

	if(!g_DeviceDetected) {
		MessageBox("ULS24 Device Not Attached", "TestBB", MB_ICONWARNING);
		return;
	}

	IntTimeDlg intDlg;
	intDlg.m_IntTime = int_time;

	float it;

	if (intDlg.DoModal() == IDOK)
	{
		it = intDlg.m_IntTime;
	}

	m_InterfaceObject.SetIntTime(it);

//	CString sbuf;
//	sbuf.Format("%.0f  ", int_time);
//	SetDlgItemText(IDC_STATIC_INTTIME, sbuf);

}

void CTestBBDlg::UpdateGUIDisplay()
{
	// TODO: Add your control notification handler code here

	CString sbuf;

	sbuf.Format("%.0f  ", int_time);
	SetDlgItemText(IDC_STATIC_INTTIME, sbuf);

	CButton *pBL = (CButton*)GetDlgItem(IDC_RADIO_L);
	CButton *pBH = (CButton*)GetDlgItem(IDC_RADIO_H);

	pBL->SetCheck(gain_mode);
	pBH->SetCheck(!gain_mode);
	m_GainMode = !gain_mode;
}


void CTestBBDlg::OnBnClickedButtona()
{
	// TODO: Add your control notification handler code here
	m_InterfaceObject.OnButtonA();
}


void CTestBBDlg::OnBnClickedButtonb()
{
	// TODO: Add your control notification handler code here
	m_InterfaceObject.OnButtonB();
}


void CTestBBDlg::OnBnClickedButtonc()
{
	// TODO: Add your control notification handler code here
	m_InterfaceObject.OnButtonC();
}


void CTestBBDlg::OnBnClickedButtonClr()
{
	// TODO: Add your control notification handler code here
	m_DisplayText.Empty();
	SetDlgItemText(IDC_EDIT_TEXT, m_DisplayText);
}
